diff -ruNp ejudge-2.3.18/prepare_out.c ejudge/prepare_out.c
--- ejudge-2.3.18/prepare_out.c	2011-04-10 09:25:24.000000000 +0400
+++ ejudge/prepare_out.c	2011-07-11 09:02:04.096281617 +0400
@@ -1,5 +1,5 @@
 /* -*- mode: c -*- */
-/* $Id: prepare_out.c 6214 2011-04-01 20:03:14Z cher $ */
+/* $Id: prepare_out.c 6246 2011-04-15 04:37:15Z cher $ */
 
 /* Copyright (C) 2005-2011 Alexander Chernov <cher@ejudge.ru> */
 
@@ -61,31 +61,6 @@ unparse_bool(FILE *f, const unsigned cha
   fprintf(f, "%s%s\n", name, value?"":" = 0");
 }
 
-#define SIZE_G (1024 * 1024 * 1024)
-#define SIZE_M (1024 * 1024)
-#define SIZE_K (1024)
-
-static unsigned char*
-num_to_size(unsigned char *buf, size_t buf_size, int num)
-{
-  if (!num) snprintf(buf, buf_size, "0");
-  else if (!(num % SIZE_G)) snprintf(buf, buf_size, "%uG", num / SIZE_G);
-  else if (!(num % SIZE_M)) snprintf(buf, buf_size, "%uM", num / SIZE_M);
-  else if (!(num % SIZE_K)) snprintf(buf, buf_size, "%uK", num / SIZE_K);
-  else snprintf(buf, buf_size, "%u", num);
-  return buf;
-}
-static unsigned char*
-size_t_to_size(unsigned char *buf, size_t buf_size, size_t num)
-{
-  if (!num) snprintf(buf, buf_size, "0");
-  else if (!(num % SIZE_G)) snprintf(buf, buf_size, "%zuG", num / SIZE_G);
-  else if (!(num % SIZE_M)) snprintf(buf, buf_size, "%zuM", num / SIZE_M);
-  else if (!(num % SIZE_K)) snprintf(buf, buf_size, "%zuK", num / SIZE_K);
-  else snprintf(buf, buf_size, "%zu", num);
-  return buf;
-}
-
 static void
 do_str(
         FILE *f,
@@ -315,18 +290,18 @@ prepare_unparse_global(FILE *f, struct s
 
   if (global->max_run_size != DFLT_G_MAX_RUN_SIZE)
     fprintf(f, "max_run_size = %s\n",
-            num_to_size(nbuf, sizeof(nbuf), global->max_run_size));
+            num_to_size_str(nbuf, sizeof(nbuf), global->max_run_size));
   if (global->max_run_total != DFLT_G_MAX_RUN_TOTAL)
     fprintf(f, "max_run_total = %s\n",
-            num_to_size(nbuf, sizeof(nbuf), global->max_run_total));
+            num_to_size_str(nbuf, sizeof(nbuf), global->max_run_total));
   if (global->max_run_num != DFLT_G_MAX_RUN_NUM)
     fprintf(f, "max_run_num = %d\n", global->max_run_num);
   if (global->max_clar_size != DFLT_G_MAX_CLAR_SIZE)
     fprintf(f, "max_clar_size = %s\n",
-            num_to_size(nbuf, sizeof(nbuf), global->max_clar_size));
+            num_to_size_str(nbuf, sizeof(nbuf), global->max_clar_size));
   if (global->max_clar_total != DFLT_G_MAX_CLAR_TOTAL)
     fprintf(f, "max_clar_total = %s\n",
-            num_to_size(nbuf, sizeof(nbuf), global->max_clar_total));
+            num_to_size_str(nbuf, sizeof(nbuf), global->max_clar_total));
   if (global->max_clar_num != DFLT_G_MAX_CLAR_NUM)
     fprintf(f, "max_clar_num = %d\n", global->max_clar_num);
   if (global->team_page_quota != DFLT_G_TEAM_PAGE_QUOTA)
@@ -334,17 +309,17 @@ prepare_unparse_global(FILE *f, struct s
 
   if (((ssize_t) global->compile_max_vm_size) > 0) {
     fprintf(f, "compile_max_vm_size = %s\n",
-            size_t_to_size(size_buf, sizeof(size_buf),
+            size_t_to_size_str(size_buf, sizeof(size_buf),
                            global->compile_max_vm_size));
   }
   if (((ssize_t) global->compile_max_stack_size) > 0) {
     fprintf(f, "compile_max_stack_size = %s\n",
-            size_t_to_size(size_buf, sizeof(size_buf),
+            size_t_to_size_str(size_buf, sizeof(size_buf),
                            global->compile_max_stack_size));
   }
   if (((ssize_t) global->compile_max_file_size) > 0) {
     fprintf(f, "compile_max_file_size = %s\n",
-            size_t_to_size(size_buf, sizeof(size_buf),
+            size_t_to_size_str(size_buf, sizeof(size_buf),
                            global->compile_max_file_size));
   }
 
@@ -486,10 +461,10 @@ prepare_unparse_global(FILE *f, struct s
     fprintf(f, "rounding_mode = %s\n", rounding_modes[global->rounding_mode]);
   if (global->max_file_length && global->max_file_length != DFLT_G_MAX_FILE_LENGTH)
     fprintf(f, "max_file_length = %s\n",
-            num_to_size(nbuf, sizeof(nbuf), global->max_file_length));
+            num_to_size_str(nbuf, sizeof(nbuf), global->max_file_length));
   if (global->max_line_length && global->max_line_length != DFLT_G_MAX_LINE_LENGTH)
     fprintf(f, "max_line_length = %s\n",
-            num_to_size(nbuf, sizeof(nbuf), global->max_line_length));
+            num_to_size_str(nbuf, sizeof(nbuf), global->max_line_length));
   if (global->disable_auto_testing != DFLT_G_DISABLE_AUTO_TESTING)
     unparse_bool(f, "disable_auto_testing", global->disable_auto_testing);
   if (global->disable_testing != DFLT_G_DISABLE_TESTING)
@@ -877,15 +852,15 @@ prepare_unparse_lang(
 
   if (lang->max_vm_size != -1L && lang->max_vm_size != 0) {
     fprintf(f, "max_vm_size = %s\n",
-            size_t_to_size(size_buf, sizeof(size_buf), lang->max_vm_size));
+            size_t_to_size_str(size_buf, sizeof(size_buf), lang->max_vm_size));
   }
   if (lang->max_stack_size != -1L && lang->max_stack_size != 0) {
     fprintf(f, "max_stack_size = %s\n",
-            size_t_to_size(size_buf, sizeof(size_buf), lang->max_stack_size));
+            size_t_to_size_str(size_buf, sizeof(size_buf), lang->max_stack_size));
   }
   if (lang->max_file_size != -1L && lang->max_file_size != 0) {
     fprintf(f, "max_file_size = %s\n",
-            size_t_to_size(size_buf, sizeof(size_buf), lang->max_file_size));
+            size_t_to_size_str(size_buf, sizeof(size_buf), lang->max_file_size));
   }
 
   if (lang->compiler_env) {
@@ -1131,19 +1106,19 @@ prepare_unparse_prob(
 
   if (prob->max_vm_size != -1L)
     fprintf(f, "max_vm_size = %s\n",
-            size_t_to_size(size_buf, sizeof(size_buf), prob->max_vm_size));
+            size_t_to_size_str(size_buf, sizeof(size_buf), prob->max_vm_size));
   if (prob->max_stack_size != -1L)
     fprintf(f, "max_stack_size = %s\n",
-            size_t_to_size(size_buf, sizeof(size_buf), prob->max_stack_size));
+            size_t_to_size_str(size_buf, sizeof(size_buf), prob->max_stack_size));
   if (prob->max_data_size != -1L)
     fprintf(f, "max_data_size = %s\n",
-            size_t_to_size(size_buf, sizeof(size_buf), prob->max_data_size));
+            size_t_to_size_str(size_buf, sizeof(size_buf), prob->max_data_size));
   if (prob->max_core_size != -1L)
     fprintf(f, "max_core_size = %s\n",
-            size_t_to_size(size_buf, sizeof(size_buf), prob->max_core_size));
+            size_t_to_size_str(size_buf, sizeof(size_buf), prob->max_core_size));
   if (prob->max_file_size != -1L)
     fprintf(f, "max_file_size = %s\n",
-            size_t_to_size(size_buf, sizeof(size_buf), prob->max_file_size));
+            size_t_to_size_str(size_buf, sizeof(size_buf), prob->max_file_size));
   if (prob->max_open_file_count >= 0) {
     fprintf(f, "max_open_file_count = %d\n", prob->max_open_file_count);
   }
diff -ruNp ejudge-2.3.18/scripts/ghc.in ejudge/scripts/ghc.in
--- ejudge-2.3.18/scripts/ghc.in	1970-01-01 03:00:00.000000000 +0300
+++ ejudge/scripts/ghc.in	2011-07-11 09:01:58.308387855 +0400
@@ -0,0 +1,37 @@
+#!/bin/sh
+# $Id: ghc.in 6385 2011-06-30 05:21:01Z cher $
+# Copyright (c) 2011 Alexander Chernov <cher@ejudge.ru>
+
+# using EJUDGE_FLAGS we may pass additional flags
+
+LANG_CONFIG_DIR="@lang_config_dir@"
+[ "${EJUDGE_LANG_CONFIG}" = "" ] && EJUDGE_LANG_CONFIG="${LANG_CONFIG_DIR}/ghc.cfg"
+
+if [ -f "${EJUDGE_LANG_CONFIG}" ]
+then
+  . "${EJUDGE_LANG_CONFIG}"
+else
+  version="unknown"
+  GHCRUN="ghc"
+  GHCDIR=
+fi
+
+if [ x"${version}" = x ]
+then
+  echo "This language is not supported." >&2
+  exit 1
+fi
+
+if [ x"${GHCDIR}" != x ]
+then
+    PATH="${GHCDIR}:${PATH}"
+fi
+
+[ x"${EJUDGE_FLAGS}" = x ] && EJUDGE_FLAGS="-O -H14m"
+
+unset LANG
+unset LC_ALL
+unset LC_MESSAGES
+unset LANGUAGE
+
+exec "${GHCRUN}" ${EJUDGE_FLAGS} "$1" -o "$2"
diff -ruNp ejudge-2.3.18/scripts/ghc-version.in ejudge/scripts/ghc-version.in
--- ejudge-2.3.18/scripts/ghc-version.in	1970-01-01 03:00:00.000000000 +0300
+++ ejudge/scripts/ghc-version.in	2011-07-11 09:01:58.327387506 +0400
@@ -0,0 +1,117 @@
+#!/bin/sh
+# $Id: ghc-version.in 6385 2011-06-30 05:21:01Z cher $
+# Copyright (c) 2011 Alexander Chernov <cher@ejudge.ru>
+
+# compiler script interface is as follows
+# <comp>-version [OPTION]
+# OPTION is:
+#  -r P fully check the availability of the compiler (like configure
+#       script does). P is a proposed path to the compiler (like in
+#       --with-<comp> configure option).
+#       returns failure (exit code 1), if the compiler is not available
+#       or is not functional.
+#       in case of success exit code is 0, and the necessary configuration
+#       variables are written to stdout.
+#  -v   verbose operation (configure mode)
+#  -l   output the compiler name to the stdout (list mode)
+#  -p   write to the stdout the command line of the compiler
+#  -f   write the compiler full name and the compiler version
+
+LANG_CONFIG_DIR="@lang_config_dir@"
+
+common_config() {
+  echo 'long_name="The Glasgow Haskell Compiler"'
+  echo 'src_sfx=".hs"'
+  echo 'arch="linux-shared"'
+  echo 'insecure=1'
+}
+
+failure() {
+  rm -f conftest*
+  echo 'version='
+  echo 'arg="'"${arg}"'"'
+  common_config
+  echo 'GHCRUN=false'
+  echo 'GHCDIR='
+  [ "${verbose}" = 1 ] && echo "no" >&2
+  exit 1
+}
+
+unset LANG
+unset LC_ALL
+unset LC_MESSAGES
+unset LANGUAGE
+
+if [ x"$1" = x-v ]
+then
+  verbose=1
+  shift
+fi
+
+# recheck the language
+if [ x"$1" = x-r ]
+then
+  arg="$2"
+  [ x"$2" != x ] && GHCRUN="$2"
+  [ "${GHCRUN}" = "" ] && GHCRUN="ghc"
+
+  [ "${verbose}" = 1 ] && echo -n "checking whether GHC is available... " >&2
+  "${GHCRUN}" --version >/dev/null 2>&1 || failure
+  version=`"${GHCRUN}" --version 2>&1 | grep "version" | gawk '{ print $8; }'`|| failure
+  cat > conftest.hs <<EOF
+main = putStrLn "ok"
+EOF
+  "${GHCRUN}" conftest.hs -o conftest >/dev/null 2>&1 || failure
+  [ -x conftest ] || failure
+  ./conftest >/dev/null 2>&1 || failure
+
+  rm -f ./conftest*
+  GHCDIR=`dirname "${GHCRUN}"`
+  [ "${GHCDIR}" = . ] && GHCDIR=""
+  echo 'version="'"${version}"'"'
+  echo 'arg="'"${arg}"'"'
+  common_config
+  echo 'GHCRUN="'"${GHCRUN}"'"'
+  echo 'GHCDIR="'"${GHCDIR}"'"'
+  [ "${verbose}" = 1 ] && echo "yes, ${GHCRUN}, ${version}" >&2
+  exit 0
+fi
+
+if [ x"$1" = x-l ]
+then
+  echo "The Glasgow Haskell [http://haskell.org/ghc]"
+  exit 0
+fi
+
+[ "${EJUDGE_LANG_CONFIG}" = "" ] && EJUDGE_LANG_CONFIG="${LANG_CONFIG_DIR}/ghc.cfg"
+
+if [ -f "${EJUDGE_LANG_CONFIG}" ]
+then
+  . "${EJUDGE_LANG_CONFIG}"
+else
+  GHCRUN="ghc"
+  GHCDIR=
+fi
+
+if [ x"${GHCRUN}" = x -o x"${GHCRUN}" = xfalse ]
+then
+  echo "This language is not supported." >&2
+  exit 1
+fi
+
+if [ x"${GHCDIR}" != x ]
+then
+    PATH="${GHCDIR}:${PATH}"
+fi
+
+if [ x"$1" = x-p ]
+then
+    echo "${GHCRUN}"
+    exit 0
+fi
+    
+"${GHCRUN}" --version >/dev/null 2>&1 || exit 1
+
+[ x"$1" = x-f ] && echo -n "The Glasgow Haskell Compiler "
+
+"${GHCRUN}" --version 2>&1 | grep "version" | gawk '{ print $8; }'
diff -ruNp ejudge-2.3.18/scripts/lang_ids.cfg ejudge/scripts/lang_ids.cfg
--- ejudge-2.3.18/scripts/lang_ids.cfg	2011-04-10 09:25:16.000000000 +0400
+++ ejudge/scripts/lang_ids.cfg	2011-07-11 09:01:58.291388167 +0400
@@ -1,4 +1,4 @@
-# $Id: lang_ids.cfg 6041 2010-11-17 22:03:39Z cher $
+# $Id: lang_ids.cfg 6385 2011-06-30 05:21:01Z cher $
 # 
 # This is language id registry. The id is assigned to each supported
 # language. If the several languages has the same id, the latter
@@ -31,3 +31,5 @@ ruby=21
 php=22
 python3=23
 kumir=24
+make=25
+ghc=26
diff -ruNp ejudge-2.3.18/scripts/make.in ejudge/scripts/make.in
--- ejudge-2.3.18/scripts/make.in	1970-01-01 03:00:00.000000000 +0300
+++ ejudge/scripts/make.in	2011-07-11 09:01:58.231389267 +0400
@@ -0,0 +1,115 @@
+#!/bin/sh
+# $Id: make.in 6385 2011-06-30 05:21:01Z cher $
+# Copyright (c) 2011 Alexander Chernov <cher@ejudge.ru>
+
+# Environment variables:
+#  EJ_MAKE_COMMAND
+#  EJ_MAKE_ARGS
+#  EJ_PROGRAM_DIR
+#  EJ_PROGRAM_NAME
+
+srcfile="$1"
+dstfile="$2"
+
+LANG_CONFIG_DIR="@lang_config_dir@"
+[ "${EJUDGE_LANG_CONFIG}" = "" ] && EJUDGE_LANG_CONFIG="${LANG_CONFIG_DIR}/make.cfg"
+
+if [ -f "${EJUDGE_LANG_CONFIG}" ]
+then
+  . "${EJUDGE_LANG_CONFIG}"
+else
+  version="generic"
+  MAKERUN="make"
+fi
+
+[ x"${EJ_MAKE_COMMAND}" != x ] || EJ_MAKE_COMMAND="make"
+[ x"${EJ_PROGRAM_DIR}" != x ] || EJ_PROGRAM_DIR="solution"
+[ x"${EJ_PROGRAM_NAME}" != x ] || EJ_PROGRAM_NAME="solution"
+
+# 1. detect the type of the archive
+#  7z:  "7-zip archive data"
+#  tar: "POSIX tar archive (GNU)"
+#  bz2: "bzip2 compressed data"
+#  gz:  "gzip compressed data"
+if [ ! -f "${srcfile}" ]
+then
+  echo "No source file ${srcfile}" 1>&2
+  exit 1
+fi
+
+t=`file "${srcfile}"`
+case "$t" in
+    *7-zip\ archive\ data*)
+        cmd="7z x";;
+    *POSIX\ tar\ archive*)
+        cmd="tar xf";;
+    *bzip2\ compressed\ data*)
+        cmd="tar xfj";;
+    *gzip\ compressed\ data*)
+        cmd="tar xfz";;
+    *)
+        echo "Unsupported file type ${t}" 1>&2
+        exit 1;;
+esac
+if [ x"${cmd}" = x ]
+then
+    echo "Unsupported file type ${t}" 1>&2
+    exit 1
+fi
+
+# 2. unpack the archive
+${cmd} "${srcfile}"
+if [ $? != 0 ]
+then
+    echo "Failed to uncompress the archive" 1>&2
+    exit 1
+fi
+if [ ! -d "${EJ_PROGRAM_DIR}" ]
+then
+    echo "The archive does not contain directory ${EJ_PROGRAM_DIR}" 1>&2
+    exit 1
+fi
+
+# 3. execute
+curdir=`pwd`
+if [ x"${curdir}" = x ]
+then
+    echo "Invalid current directory" 1>&2
+    exit 1
+fi
+
+if ! cd "${EJ_PROGRAM_DIR}"
+then
+    echo "Failed to change the current directory to ${EJ_PROGRAM_DIR}" 1>&2
+    exit 1
+fi
+
+${EJ_MAKE_COMMAND} ${EJ_MAKE_ARGS}
+if [ $? != 0 ]
+then
+    echo "Build failed" 1>&2
+    exit 1
+fi
+
+if [ ! -x "${EJ_PROGRAM_NAME}" ]
+then
+    echo "The executable file is not created or non-existable" 1>&2
+    exit 1
+fi
+
+# 4. copy the result
+cd "${curdir}"
+if [ $? != 0 ]
+then
+    echo "Invalid current directory" 1>&2
+    exit 1
+fi
+
+mv "${EJ_PROGRAM_DIR}"/"${EJ_PROGRAM_NAME}" "${dstfile}"
+if [ $? != 0 ]
+then
+    echo "Failed to move the executable file" 1>&2
+    exit 1
+fi
+
+exit 0
diff -ruNp ejudge-2.3.18/scripts/make-version.in ejudge/scripts/make-version.in
--- ejudge-2.3.18/scripts/make-version.in	1970-01-01 03:00:00.000000000 +0300
+++ ejudge/scripts/make-version.in	2011-07-11 09:01:58.246388991 +0400
@@ -0,0 +1,85 @@
+#!/bin/sh
+# $Id: make-version.in 6385 2011-06-30 05:21:01Z cher $
+# Copyright (c) 2011 Alexander Chernov <cher@ejudge.ru>
+
+# This is a version script for a generic build system.
+# It supports make, ant, scons, etc...
+# Compilation of a submit is directed by several
+# environment variables.
+
+LANG_CONFIG_DIR="@lang_config_dir@"
+
+common_config() {
+  echo 'long_name="Generic build"'
+  echo 'src_sfx=".tar"'
+  echo 'arch="linux-shared"'
+}
+
+failure() {
+  rm -f conftest*
+  echo 'version='
+  echo 'arg="'"${arg}"'"'
+  common_config
+  echo 'MAKEPATH=/bin/false'
+  [ "${verbose}" = 1 ] && echo "no" >&2
+  exit 1
+}
+
+unset LANG
+unset LC_ALL
+unset LC_MESSAGES
+unset LANGUAGE
+
+if [ x"$1" = x-v ]
+then
+  verbose=1
+  shift
+fi
+
+# recheck the language
+if [ x"$1" = x-r ]
+then
+  arg="$2"
+
+  [ "${verbose}" = 1 ] && echo -n "checking whether make is available... " >&2
+
+  version=generic
+  echo 'version="'"${version}"'"'
+  echo 'arg="'"${arg}"'"'
+  echo 'binary=1'
+  common_config
+  echo 'MAKEPATH=/usr/bin/make'
+  [ "${verbose}" = 1 ] && echo "yes, ${version}" >&2
+  exit 0
+fi
+
+if [ x"$1" = x-l ]
+then
+  echo "Generic build"
+  exit 0
+fi
+
+[ "${EJUDGE_LANG_CONFIG}" = "" ] && EJUDGE_LANG_CONFIG="${LANG_CONFIG_DIR}/make.cfg"
+
+if [ -f "${EJUDGE_LANG_CONFIG}" ]
+then
+  . "${EJUDGE_LANG_CONFIG}"
+else
+  MAKEPATH="/usr/bin/make"
+fi
+
+if [ x"${MAKEPATH}" = x -o x"${MAKEPATH}" = x/bin/false ]
+then
+  echo "This language is not supported." >&2
+  exit 1
+fi
+
+if [ x"$1" = x-p ]
+then
+    echo "${MAKEPATH}"
+    exit 0
+fi
+
+[ x"$1" = x-f ] && echo -n "Make "
+
+echo "generic"
diff -ruNp ejudge-2.3.18/serve_2.c ejudge/serve_2.c
--- ejudge-2.3.18/serve_2.c	2011-04-10 09:25:24.000000000 +0400
+++ ejudge/serve_2.c	2011-07-11 09:02:04.120281176 +0400
@@ -1,5 +1,5 @@
 /* -*- mode: c -*- */
-/* $Id: serve_2.c 6229 2011-04-07 08:49:11Z cher $ */
+/* $Id: serve_2.c 6393 2011-07-04 20:54:33Z cher $ */
 
 /* Copyright (C) 2006-2011 Alexander Chernov <cher@ejudge.ru> */
 
@@ -1615,9 +1615,10 @@ serve_read_compile_packet(
   struct compile_reply_packet *comp_pkt = 0;
   long report_size = 0;
   unsigned char errmsg[1024] = { 0 };
-  unsigned char *team_name = 0;
+  //unsigned char *team_name = 0;
   struct compile_run_extra *comp_extra = 0;
   struct section_problem_data *prob = 0;
+  struct section_language_data *lang = 0;
   int arch_flags;
   path_t run_arch_path;
   char *run_text = 0;
@@ -1733,6 +1734,9 @@ serve_read_compile_packet(
     snprintf(errmsg, sizeof(errmsg), "invalid problem %d\n", re.prob_id);
     goto report_check_failed;
   }
+  if (re.lang_id > 1 && re.lang_id <= state->max_lang) {
+    lang = state->langs[re.lang_id];
+  }
   /*
   if (re.lang_id < 1 || re.lang_id > state->max_lang
       || !(lang = state->langs[re.lang_id])) {
@@ -1740,10 +1744,12 @@ serve_read_compile_packet(
     goto report_check_failed;
   }
   */
+  /*
   if (!(team_name = teamdb_get_name(state->teamdb_state, re.user_id))) {
     snprintf(errmsg, sizeof(errmsg), "invalid team %d\n", re.user_id);
     goto report_check_failed;
   }
+  */
   if (prob->disable_testing && prob->enable_compilation > 0) {
     if (run_change_status_4(state->runlog_state, comp_pkt->run_id,
                             RUN_ACCEPTED) < 0)
@@ -1764,13 +1770,12 @@ serve_read_compile_packet(
    * so far compilation is successful, and now we prepare a run packet
    */
 
-  if (prob && prob->type > 0 && prob->style_checker_cmd
-      && prob->style_checker_cmd[0]) {
-    // copy textual representation
+  if ((prob && prob->style_checker_cmd && prob->style_checker_cmd[0])
+      || (lang && lang->style_checker_cmd && lang->style_checker_cmd[0])) {
     snprintf(pkt_name, sizeof(pkt_name), "%06d", comp_pkt->run_id);
-    snprintf(run_arch_path, sizeof(run_arch_path), "%s/%s",
+    snprintf(run_arch_path, sizeof(run_arch_path), "%s/%s.txt",
              compile_report_dir, pkt_name);
-    if (generic_read_file(&run_text, 0, &run_size, 0, 0, run_arch_path, 0)>=0){
+    if (generic_read_file(&run_text, 0, &run_size, 0, 0, run_arch_path, 0) >= 0){
       arch_flags = archive_make_write_path(state,
                                            run_arch_path, sizeof(run_arch_path),
                                            global->report_archive_dir,
@@ -1784,7 +1789,9 @@ serve_read_compile_packet(
       }
       xfree(run_text); run_text = 0; run_size = 0;
     }
+  }
 
+  if (prob && prob->type > 0 && prob->style_checker_cmd && prob->style_checker_cmd[0]) {
     arch_flags = archive_make_read_path(state, run_arch_path,
                                         sizeof(run_arch_path),
                                         state->global->run_archive_dir,
diff -ruNp ejudge-2.3.18/serve-control.c ejudge/serve-control.c
--- ejudge-2.3.18/serve-control.c	2011-04-10 09:25:24.000000000 +0400
+++ ejudge/serve-control.c	2011-07-11 09:02:04.790268858 +0400
@@ -1,5 +1,5 @@
 /* -*- mode: c -*- */
-/* $Id: serve-control.c 6214 2011-04-01 20:03:14Z cher $ */
+/* $Id: serve-control.c 6351 2011-05-24 19:28:45Z cher $ */
 
 /* Copyright (C) 2004-2011 Alexander Chernov <cher@ejudge.ru> */
 
@@ -1498,6 +1498,8 @@ static const int next_action_map[SSERV_C
   [SSERV_CMD_CNTS_CLEAR_TEAM_URL] = SSERV_CMD_EDIT_CURRENT_CONTEST,
   [SSERV_CMD_CNTS_CLEAR_STANDINGS_URL] = SSERV_CMD_EDIT_CURRENT_CONTEST,
   [SSERV_CMD_CNTS_CLEAR_PROBLEMS_URL] = SSERV_CMD_EDIT_CURRENT_CONTEST,
+  [SSERV_CMD_CNTS_CLEAR_LOGO_URL] = SSERV_CMD_EDIT_CURRENT_CONTEST,
+  [SSERV_CMD_CNTS_CLEAR_CSS_URL] = SSERV_CMD_EDIT_CURRENT_CONTEST,
   [SSERV_CMD_CNTS_CLEAR_ROOT_DIR] = SSERV_CMD_EDIT_CURRENT_CONTEST,
   [SSERV_CMD_CNTS_CLEAR_CONF_DIR] = SSERV_CMD_EDIT_CURRENT_CONTEST,
   [SSERV_CMD_CNTS_CLEAR_USERS_HEADER_TEXT] = SSERV_CMD_EDIT_CURRENT_CONTEST,
@@ -1585,6 +1587,8 @@ static const int next_action_map[SSERV_C
   [SSERV_CMD_CNTS_CHANGE_TEAM_URL] = SSERV_CMD_EDIT_CURRENT_CONTEST,
   [SSERV_CMD_CNTS_CHANGE_STANDINGS_URL] = SSERV_CMD_EDIT_CURRENT_CONTEST,
   [SSERV_CMD_CNTS_CHANGE_PROBLEMS_URL] = SSERV_CMD_EDIT_CURRENT_CONTEST,
+  [SSERV_CMD_CNTS_CHANGE_LOGO_URL] = SSERV_CMD_EDIT_CURRENT_CONTEST,
+  [SSERV_CMD_CNTS_CHANGE_CSS_URL] = SSERV_CMD_EDIT_CURRENT_CONTEST,
   [SSERV_CMD_CNTS_CHANGE_ROOT_DIR] = SSERV_CMD_EDIT_CURRENT_CONTEST,
   [SSERV_CMD_CNTS_CHANGE_CONF_DIR] = SSERV_CMD_EDIT_CURRENT_CONTEST,
   [SSERV_CMD_CNTS_CHANGE_DIR_MODE] = SSERV_CMD_EDIT_CURRENT_CONTEST,
@@ -2303,6 +2307,8 @@ main(int argc, char *argv[])
   case SSERV_CMD_CNTS_CHANGE_TEAM_URL:
   case SSERV_CMD_CNTS_CHANGE_STANDINGS_URL:
   case SSERV_CMD_CNTS_CHANGE_PROBLEMS_URL:
+  case SSERV_CMD_CNTS_CHANGE_LOGO_URL:
+  case SSERV_CMD_CNTS_CHANGE_CSS_URL:
   case SSERV_CMD_CNTS_CHANGE_ROOT_DIR:
   case SSERV_CMD_CNTS_CHANGE_CONF_DIR:
   case SSERV_CMD_CNTS_CHANGE_DIR_MODE:
@@ -2431,6 +2437,8 @@ main(int argc, char *argv[])
   case SSERV_CMD_CNTS_CLEAR_TEAM_URL:
   case SSERV_CMD_CNTS_CLEAR_STANDINGS_URL:
   case SSERV_CMD_CNTS_CLEAR_PROBLEMS_URL:
+  case SSERV_CMD_CNTS_CLEAR_LOGO_URL:
+  case SSERV_CMD_CNTS_CLEAR_CSS_URL:
   case SSERV_CMD_CNTS_CLEAR_ROOT_DIR:
   case SSERV_CMD_CNTS_CLEAR_CONF_DIR:
   case SSERV_CMD_CNTS_CLEAR_DIR_MODE:
diff -ruNp ejudge-2.3.18/sformat.c ejudge/sformat.c
--- ejudge-2.3.18/sformat.c	2011-04-10 09:25:24.000000000 +0400
+++ ejudge/sformat.c	2011-07-11 09:02:04.804268600 +0400
@@ -1,5 +1,5 @@
 /* -*- mode: c -*- */
-/* $Id: sformat.c 6185 2011-03-27 15:16:29Z cher $ */
+/* $Id: sformat.c 6345 2011-05-23 04:20:49Z cher $ */
 
 /* Copyright (C) 2001-2011 Alexander Chernov <cher@ejudge.ru> */
 
@@ -37,6 +37,7 @@
 /**
  * Valid format conversions as follows:
  *  G - global data
+ *   Gr - contest root directory
  *  P - problem data
  *   Pi - problem id
  *   Ps - problem short name
@@ -297,8 +298,13 @@ sformat_message(
       /* read specification */
       switch (*pf) {
       case 'G':
+        /*
+         * Gr - contest root directory
+         */
         pf++;
         switch (*pf) {
+        case 'r':
+          break;
         case 0:
           is_invalid = 1;
           break;
@@ -310,6 +316,9 @@ sformat_message(
         if (!is_invalid && !glob_data) is_invalid = 1;
         if (!is_invalid) {
           switch (*pf) {
+          case 'r':
+            papp = glob_data->root_dir;
+            break;
           default:
             abort();
           }
diff -ruNp ejudge-2.3.18/style/ejudge-upgrade-web.in ejudge/style/ejudge-upgrade-web.in
--- ejudge-2.3.18/style/ejudge-upgrade-web.in	2011-04-10 09:25:20.000000000 +0400
+++ ejudge/style/ejudge-upgrade-web.in	2011-07-11 09:02:02.129317756 +0400
@@ -1,6 +1,6 @@
 #! /bin/sh
-# $Id: ejudge-upgrade-web.in 5521 2008-12-28 09:18:13Z cher $
-# Copyright (c) 2008 Alexander Chernov <cher@ejudge.ru>
+# $Id: ejudge-upgrade-web.in 6270 2011-04-27 05:04:59Z cher $
+# Copyright (c) 2008-2011 Alexander Chernov <cher@ejudge.ru>
 
 # This script upgrades the web installation of the ejudge system
 
@@ -107,7 +107,7 @@ then
 fi
 
 # symlink the necessary style files
-for i in logo.gif priv.css unpriv.css priv.js unpriv.js filter_expr.html icons
+for i in logo.gif priv.css unpriv.css priv.js unpriv.js filter_expr.html icons sprintf.js
 do
     if ! ln -sf "${datadir}/ejudge/style/${i}" "${i}"
     then
diff -ruNp ejudge-2.3.18/style/sprintf.js ejudge/style/sprintf.js
--- ejudge-2.3.18/style/sprintf.js	1970-01-01 03:00:00.000000000 +0300
+++ ejudge/style/sprintf.js	2011-07-11 09:02:02.112318069 +0400
@@ -0,0 +1,181 @@
+function sprintf () {
+    // http://kevin.vanzonneveld.net
+    // +   original by: Ash Searle (http://hexmen.com/blog/)
+    // + namespaced by: Michael White (http://getsprink.com)
+    // +    tweaked by: Jack
+    // +   improved by: Kevin van Zonneveld (http://kevin.vanzonneveld.net)
+    // +      input by: Paulo Freitas
+    // +   improved by: Kevin van Zonneveld (http://kevin.vanzonneveld.net)
+    // +      input by: Brett Zamir (http://brett-zamir.me)
+    // +   improved by: Kevin van Zonneveld (http://kevin.vanzonneveld.net)
+    // *     example 1: sprintf("%01.2f", 123.1);
+    // *     returns 1: 123.10
+    // *     example 2: sprintf("[%10s]", 'monkey');
+    // *     returns 2: '[    monkey]'
+    // *     example 3: sprintf("[%'#10s]", 'monkey');
+    // *     returns 3: '[####monkey]'
+    var regex = /%%|%(\d+\$)?([-+\'#0 ]*)(\*\d+\$|\*|\d+)?(\.(\*\d+\$|\*|\d+))?([scboxXuidfegEG])/g;
+    var a = arguments,
+        i = 0,
+        format = a[i++];
+
+    // pad()
+    var pad = function (str, len, chr, leftJustify) {
+        if (!chr) {
+            chr = ' ';
+        }
+        var padding = (str.length >= len) ? '' : Array(1 + len - str.length >>> 0).join(chr);
+        return leftJustify ? str + padding : padding + str;
+    };
+
+    // justify()
+    var justify = function (value, prefix, leftJustify, minWidth, zeroPad, customPadChar) {
+        var diff = minWidth - value.length;
+        if (diff > 0) {
+            if (leftJustify || !zeroPad) {
+                value = pad(value, minWidth, customPadChar, leftJustify);
+            } else {
+                value = value.slice(0, prefix.length) + pad('', diff, '0', true) + value.slice(prefix.length);
+            }
+        }
+        return value;
+    };
+
+    // formatBaseX()
+    var formatBaseX = function (value, base, prefix, leftJustify, minWidth, precision, zeroPad) {
+        // Note: casts negative numbers to positive ones
+        var number = value >>> 0;
+        prefix = prefix && number && {
+            '2': '0b',
+            '8': '0',
+            '16': '0x'
+        }[base] || '';
+        value = prefix + pad(number.toString(base), precision || 0, '0', false);
+        return justify(value, prefix, leftJustify, minWidth, zeroPad);
+    };
+
+    // formatString()
+    var formatString = function (value, leftJustify, minWidth, precision, zeroPad, customPadChar) {
+        if (precision != null) {
+            value = value.slice(0, precision);
+        }
+        return justify(value, '', leftJustify, minWidth, zeroPad, customPadChar);
+    };
+
+    // doFormat()
+    var doFormat = function (substring, valueIndex, flags, minWidth, _, precision, type) {
+        var number;
+        var prefix;
+        var method;
+        var textTransform;
+        var value;
+
+        if (substring == '%%') {
+            return '%';
+        }
+
+        // parse flags
+        var leftJustify = false,
+            positivePrefix = '',
+            zeroPad = false,
+            prefixBaseX = false,
+            customPadChar = ' ';
+        var flagsl = flags.length;
+        for (var j = 0; flags && j < flagsl; j++) {
+            switch (flags.charAt(j)) {
+            case ' ':
+                positivePrefix = ' ';
+                break;
+            case '+':
+                positivePrefix = '+';
+                break;
+            case '-':
+                leftJustify = true;
+                break;
+            case "'":
+                customPadChar = flags.charAt(j + 1);
+                break;
+            case '0':
+                zeroPad = true;
+                break;
+            case '#':
+                prefixBaseX = true;
+                break;
+            }
+        }
+
+        // parameters may be null, undefined, empty-string or real valued
+        // we want to ignore null, undefined and empty-string values
+        if (!minWidth) {
+            minWidth = 0;
+        } else if (minWidth == '*') {
+            minWidth = +a[i++];
+        } else if (minWidth.charAt(0) == '*') {
+            minWidth = +a[minWidth.slice(1, -1)];
+        } else {
+            minWidth = +minWidth;
+        }
+
+        // Note: undocumented perl feature:
+        if (minWidth < 0) {
+            minWidth = -minWidth;
+            leftJustify = true;
+        }
+
+        if (!isFinite(minWidth)) {
+            throw new Error('sprintf: (minimum-)width must be finite');
+        }
+
+        if (!precision) {
+            precision = 'fFeE'.indexOf(type) > -1 ? 6 : (type == 'd') ? 0 : undefined;
+        } else if (precision == '*') {
+            precision = +a[i++];
+        } else if (precision.charAt(0) == '*') {
+            precision = +a[precision.slice(1, -1)];
+        } else {
+            precision = +precision;
+        }
+
+        // grab value using valueIndex if required?
+        value = valueIndex ? a[valueIndex.slice(0, -1)] : a[i++];
+
+        switch (type) {
+        case 's':
+            return formatString(String(value), leftJustify, minWidth, precision, zeroPad, customPadChar);
+        case 'c':
+            return formatString(String.fromCharCode(+value), leftJustify, minWidth, precision, zeroPad);
+        case 'b':
+            return formatBaseX(value, 2, prefixBaseX, leftJustify, minWidth, precision, zeroPad);
+        case 'o':
+            return formatBaseX(value, 8, prefixBaseX, leftJustify, minWidth, precision, zeroPad);
+        case 'x':
+            return formatBaseX(value, 16, prefixBaseX, leftJustify, minWidth, precision, zeroPad);
+        case 'X':
+            return formatBaseX(value, 16, prefixBaseX, leftJustify, minWidth, precision, zeroPad).toUpperCase();
+        case 'u':
+            return formatBaseX(value, 10, prefixBaseX, leftJustify, minWidth, precision, zeroPad);
+        case 'i':
+        case 'd':
+            number = (+value) | 0;
+            prefix = number < 0 ? '-' : positivePrefix;
+            value = prefix + pad(String(Math.abs(number)), precision, '0', false);
+            return justify(value, prefix, leftJustify, minWidth, zeroPad);
+        case 'e':
+        case 'E':
+        case 'f':
+        case 'F':
+        case 'g':
+        case 'G':
+            number = +value;
+            prefix = number < 0 ? '-' : positivePrefix;
+            method = ['toExponential', 'toFixed', 'toPrecision']['efg'.indexOf(type.toLowerCase())];
+            textTransform = ['toString', 'toUpperCase']['eEfFgG'.indexOf(type) % 2];
+            value = prefix + Math.abs(number)[method](precision);
+            return justify(value, prefix, leftJustify, minWidth, zeroPad)[textTransform]();
+        default:
+            return substring;
+        }
+    };
+
+    return format.replace(regex, doFormat);
+}
